<script lang="ts">
    import { description } from '../common/description'
    import { debug } from '../common/debug'
    import { options, Options } from './options'
    import format from 'date-fns/format'

    const localStorageKey = `hnet-dashboard-selection-${$description.filename}`
    let datetime = load()?.datetime

    function load(): any {
        const json = localStorage.getItem(localStorageKey)
        return json ? JSON.parse(json) : undefined
    }

    function save(obj: any) {
        localStorage.setItem(localStorageKey, JSON.stringify(obj))
    }

    function loadOptions() {
        const obj = load()
        if (obj) {
            $options = Options.fromPlain(obj.options)
        }
    }

    function saveOptions() {
        const obj = {
            datetime: format(new Date(), 'yyyy-MM-dd HH:mm:ss'),
            options: $options.toPlain()
        }
        save(obj)
        datetime = load()?.datetime
    }

    function deleteOptions() {
        localStorage.removeItem(localStorageKey)
        datetime = undefined
    }

</script>

<div>
    {#if $debug}
        <button class="border border-donkerblauw p-2 m-1 text-donkerblauw" on:click={saveOptions}>
            Save selection
        </button>
    {/if}

    {#if datetime}
        <button class="border border-donkerblauw p-2 m-1 text-donkerblauw" on:click={loadOptions}>
            Load selection {datetime}
            <button on:click|stopPropagation={deleteOptions}
                    class="font-bold text-red-600 px-1 hover:bg-red-600 hover:text-white">
                &times;
            </button>
        </button>
    {/if}
</div>